import { MountedNode } from '../mounted-node';
import { BaseRouter } from './base-router';
import type { BackAction, BatchAction, NavigateAction, PopAction, RouterActions } from '../actions/types';
import type { InitialStateOptions, ReducerResult, RouterReducer, RouterState, StackRouterState } from '../routeable';
import type { BaseOptions } from './base-router';
export interface StackOptions extends BaseOptions {
    headerComponentName?: string;
    headerMode?: string;
}
export declare class StackRouter extends BaseRouter implements RouterReducer {
    dispatch(action: RouterActions, state: RouterState): ReducerResult;
    navigate(action: NavigateAction, state: RouterState): ReducerResult;
    delegateToActiveChildRouters(action: RouterActions, state: RouterState): ReducerResult | void;
    navigateToPreexisting(action: NavigateAction, state: RouterState): ReducerResult | void;
    navigateToNew(action: NavigateAction, state: RouterState): ReducerResult | void;
    goBack(action: BackAction, _state: RouterState): ReducerResult;
    popStack(action: PopAction, state: RouterState): ReducerResult;
    batch(action: BatchAction, state: RouterState): ReducerResult;
    getInitialState(options?: InitialStateOptions): StackRouterState;
    reconcile(routerState: RouterState, mountedNode: MountedNode): void;
}
