import { MountedNode } from '../mounted-node';
import { BaseRouter } from './base-router';
import type { NavigateAction, RouterActions } from '../actions/types';
import type { InitialStateOptions, ReducerResult, RouteableReducer, RouteableState, RouterReducer, RouterState } from '../routeable';
import type { BaseOptions } from './base-router';
export declare type SwitchOptions = BaseOptions;
export declare class SwitchRouter extends BaseRouter implements RouterReducer {
    defaultKey: string;
    dispatch(action: RouterActions, state: RouterState): ReducerResult;
    navigate(action: NavigateAction, state: RouterState): ReducerResult;
    navigateAway(action: NavigateAction, state: RouterState): ReducerResult;
    switchToRoute(state: RouterState, childRouteState: RouteableState, i: number): ReducerResult;
    getInitialState(options?: InitialStateOptions): RouterState;
    resetChildRoute(routeable: RouteableReducer): RouteableState;
    reconcile(routerState: RouterState, mountedNode: MountedNode): void;
}
