
10/17/2018

What we REALLY have is a NavigationObject and other state. And we should
represent them as the same.

NavigationObject is "what is the user looking at".

What is the user trying to see.

And it can be optionally serialized (but should be in most cases so it can
wind up in the URL).

When the url is `/foo/bar/baz`, the NavigationObject points to some shit.

Maybe the Navigation object is handler infos.

```
[
  {
    name: "foo",
  },
  {
    name: "bar",
  },
  {
    name: "baz",
  },

]
```

But the navigation object needs to be piecemeal verified. I think route recognizer
has a sort of bidirectional parsing... I should actually try and prove this.
RRv4 doesn't get trolled by this. 

I still suspect that this is some kind of weaving that needs to happen. Let's
do `/foo/bar/baz` again, assuming one "node" per word. Starting from root.

```
root node: {
  nav: ['application', 'foo', ...],

  // ok so nav says i want to go to foo. How does that actually get installed/reconciled?
  // does root decide how to render foo, or does foo?
  // right now we have routes that decide which parent route they render into.
  // But I want to switch that around; 
  // the root provides an outlet for the app to render into.

  publish outlet;


  // root node "subscribes" to applicationNode,
  // passing it all the outlets it needs to render.
  applicationNode.subscribeTo(outlet);

  // in glimmer template terms:
  // {{outlet 'nameThatIsReferenceableInTheTemplate'}}
  // {{application outlet=nameThatIsReferenceableInTheTemplate}}

  // or we can break this down further:
  // outlets are like pipes. The Root Node says I have a pipe.
  // and in the root node template it can say {{pipe}}, which is
  // the "read" end of the pipe; the root node is simply specifying
  // where to place the content that child nodes render into.
  // It's probably OK if merely placing the {{outlet}} in the node's
  // template serves as a definition of the pipe; there is no point
  // in declaring a pipe that never gets read-from/rendered.

  // so the root node (or any):
  // - declares or passes through outlet-writables that children can render into,
  //   regardless of what the navigation object dictates that it render.
  //   - perhaps we could make the system flexible to introspect
  //     from the navigation _what_ will be rendered to in order
  //     to select a different outlet-writeable to send it? Not sure
  //     what the use case is but might be cool.
  // - 
}

application node: {
  injects/rendersTo: outlet;

}



The stateful diff is easier for us than react because array order isn't considered;
rather it's just named shit. For react you don't name each element you put on the screen.

https://infernojs.org/docs/guides/benefits/list-rendering

Or maybe this is exactly what happens? $HasKeyedChildren.

My idea is basically:

{
  thing1: {...},
  thing2: {...},
  thing3: {...},
}

It doesn't matter what order these are declared in. This is similar to

1st render:

<div>
  <State key="thing1" />
  <State key="thing2" />
  <State key="thing3" />
</div>


2nd render:

<div>
  <State key="thing3" />
  <State key="thing1" />
  <State key="thing2" />
</div>
```

Internally, React/Inferno is going to loop through the old and new and can easily find the keys
blah blah. 

computedLive(function() {
  // technically this has order too because POJOs have order.
  // but for things we'd use this for
  return {
    foo: new StateFactory('x-foo'),
    bar: new StateFactory('x-bar'),
    baz: new StateFactory('x-baz'),
  };
}),


Elm has a keyedlist which is "kind of like Html.Keyed but for your data model".

https://package.elm-lang.org/packages/mrpinsky/elm-keyed-list/latest/KeyedList#keyedMap

The keyedMap method apparently makes it easy to map over of list of things that
are already keyed so that they can efficiently be rendered?

```
// Model is a type. It has a submobels field which is a KeyedList of SubModels.
type alias Model =
    { submodels : KeyedList SubModel
      ...
    }

// View is a fn that takes a Model and maps to an Html Msg (?) what is this syntax.
view : Model -> Html Msg
view model =
    keyedMap viewKeyedSubmodel model.submodels
        |> div []

viewKeyedSubmodel : Key -> SubModel -> Html Msg
viewKeyedSubmodel key submodel =
    div [ onClick <| Click key ] [ SubModel.view submodel ]
```


So I am getting caught up on some stupid bullshit about wanting to use inferno or
some other vdom library to do what i want. But I am getting confused about trees again.
VDOM solves the problem of "data has changed, so rebuild the entire tree" but it still
leaves it up to the user to decide how the data changes. Our problem with ember-rideshare
is more complex and nuanced: given constraints and their invalidations, how do you _decide_
how the data can change? In a way, the data changes from the top-level, so something
needs to walk from root to leaf until it finds some kind of invalidation that it needs
to figure out how to correct.

a---b---c---d---e---f
A---b---c---d---e---f
A---B---c---d---e---f
A---B---C---d---e---f
A---B---C---D---e---f
A---B---C---D---E---f
A---B---C---D---E---F

root---menu---activePurchase---cart

Lets consider two things that can happen:

- purchase state moves to abandoned
- purchase state moves to awaiting_merchant_approval

x

- root---menu
- root---menu---activePurchase---cart

First off, need to consider where activePurchase lives? It lives on root:

```
root: {
  nav: ...,
  activePurchase: Maybe<Purchase>,
}

menu: {
  // does menu "have" / own navigation?
  // or does it get passed in a snippet of it?
  // the thing is, ultimately it gets to decide
  // where to go here???
  // or it has a chance to redirect?
  nav: ...,
}

activePurchase: {
  nav: [..., cart,],
  inject activePurchase;

  // constraint: activePurchase.state != abandoned,

  // implicit constraint: child nodes are valid.


  childInvalidated(reason) {
    // this needs to synchronously return a value.
    // no side-effects, no async, just "fix" the problem the best it can.
    // this does not run if this own node's `constraint` fails.
    // this feels a bit weird... _which_ constraint? which child?


    // here are all the constraints from this node down:
    // I am display a node that is valid.
    // so like, node become invalid.
    // when a node

    // so this fn should be called `handleInvalidation`.
    // it can either fix the state here, or bubble the invalidation.
    
    // so maybe there's no need to define a constaint of state != abandoned;
    // we can just define a nav for each state we know of.
    // but then we have a weird thing where all of these states also
    // need to restate the state here.

    // how do we do the following:
    // validate entry into the child state,
    // decide where to go if validation fails?

    // also there needs to be an easy way to transition into active purchase
    // and let it do the correct transition.
    // e.g. implicit .index route which always fails validation.
    // then again there's no diff between .index and any other; the validations
    // will still self correct.

    // ACTUALLY: use case for letting child routes do validation, even if it's duplicate:
    // some routes are accessible for two parent routes. You still have to choose which one
    // to go to by default.
    

    // maybe we use a DSL to write two fns.

    validation: nav is in the right place
    onConstraintValidation: put nav in the right place or bubble

    validation: computed('activePurchase.state', function() {
      let state = activePurchase.state;

    }),


    // alternatively: we could pass in this handler as a sort of RRv4 <Redirect >?
    // but it wouldn't really be any different.
    // IDEA: we can kind of model this as Erlang/Elixir: fail fast and let the supervisor
    // (the parent route) fix things up.

    onConstraintValidation() {
      let state = activePurchase.state;
      switch(state) {
        case "cart":
          // goes to implicit index route, i.e. cart will decide
          // whether to go based on some additional state.
          return redirectTo('./cart');
        case "waiting_for_approval":
          return redirectTo('./waiting_for_approval');
        case "jesus":
          return redirectTo('./come_to_jesus');
        default:
          return invalid(); // maybe returning null/undefined just bubbles.
      }
    }

    // so really the api is:
    // 1. declare constraints
    // 2. declare a handler for "fixing" constraints; must be synchronous /
    //    preferably immutable.
    // 3. a "node" can bubble a constraint failure if it doesn't know how to fix
    // 4. a nav object is just a piece of data that can be fixed 
    
    // in a way this system is like redux with constraint invalidations driven by observers.
    // if that's true, why don't i "just use redux"?

    // Exercise: express this problem using redux:
    // { name: 'root', nav: {}, node: {},  }
    // action: state change; you have to put it in store, AND revalidate every possible place
    // that is using it.

    // the hard part about redux is that you have to start at the root, traverse to the existing nodes,
    // and run the bubbling algorithm yourself. You CAN do that... but you'd want to use a library?
    // but you could also stash a cache/index in your state tree to make this easier... doubly linked list etc.

    // one nice pattern here is the implicit / default node, which can do a transitionTo based on the state.
    // i wonder why we didn't do this before with routes instead of the `redirect` hack where it lets you
    // redirect into a child.


    // SO: TL;DR
    // build a Node class.
    // Nodes "mount" (tasks can be attached to them etc.)

    // use buschtoens patch-method for importing from a DSL.



    export default class extends Node {
      foo: 123,
      get validation() {
        return equal('foo', 123);
      },

      handleInvalidation(info) {
      }
    }

    import { validates } from 'cool-constraint-dsl';

    @validates('purchaseIsActive')
    export default class extends Node {
      // ...
    }
  }

  chooseBestChildRoute() {
    switch(activePurchase.state) {
      default:
        this.invalidate();
    }
  }
}

cart: {
  nav: ...,
  inject activePurchase;

  constraint: activePurchase.state == in_cart,
}

awaiting_approval: {
  nav: ...,
  inject activePurchase;

  constraint: activePurchase.state == awaiting_approval,
}

complete: {
  nav: ...,
  inject activePurchase;

  constraint: activePurchase.state == complete,
}
```

Potentially brilliant idea: order of revalidation goes TOP to BOTTOM. What does that mean? I don't know.
Something about how in some cases "nav" should win, and others "activePurchase" should win. But I still
don't know enough about invalidation to know what that means.

- abandoned on root-menu
- abandoned on activePurchase---cart
- awaiting_merchant_approval on root-menu
- awaiting_merchant_approval on activePurchase---cart










Is it possible to use static compilation for route recognizer? Yes, but challenges:

- router.map would have to be statically analyzable
- route recognizer would have to be type script aware
- at the time of static analysis, all the interfaces would have to be specified

```
import { codeTemplate } from 'glimmer';

class Node {
  // This doesn't make sense. Model is stupid.
  // You MAYBE want temporarily added RIB
  model<T>(NodeArgs<T>) : someShit {
  },

  foo = 123,
  @tracked other = 999
  @codeTemplate children() {
    return ChildNode({ a: 123, infos: infos,  });
  }
}

class RootNode extends Node {
}



class UserNode extends Node {
  @inject @urlParam userId;



  buildChildren() {

  }
}

class PostsNode extends Node {
  // children can also inject URL params from their parent.
  // parents can provide params for their children???
  @inject @urlParam userId;


}

router.add([
  { path: "/", handler: IRootNode },
  { path: "/UserId/:userId", handler: IUserNode }
  { path: "/posts", handler: IPostsNode }
]);




import IRootNode from 'nodes/root';
import IUserNode from 'nodes/root';
import IPostsNode from 'nodes/root';

// these imports could be generated / assumed;
// stringly typed but statically analyzed.

router.add([
  { path: "/", handler: IRootNode },
  { path: "/UserId/:userId", handler: IUserNode }
  { path: "/posts", handler: IPostsNode }
]);








nodes.json

// TLDR youre "map" file generates stuff,
// modules that Provide injections, other things.
// If you change something 

// implicit root
export default {
  children: {
    main: {
      loggedIn: {
      },
      loggedOut: {
        loggedOut: {
        },
      },
    }
  }
};


```
import ChildNodeBuilder from 'builder:oh-shitch/child-node';

    buildChildren() {
      return {
        main: ChildNodeBuilder.build(
          state: wat(),
          props: wat(),
          di: di,
          di: EmptyDep(),

          // difference b/w di and props?
        )
      };
    }
```






// TODO:
assume no async, just get stuff working.



```
  // <A><B><C></C></B></A>
  // A.constructor
  // - this is created as part of the patch
  // A.render
  // B.constructor
  // B.render
  // C.constructor
  // C.render

  // then say we change A.state/props
  // A.render()
  // - returns <B> with same props {}. bprops.key is same, preserves component.
  // B.render()
  // - same, but let's pretend cProps is changed. We match on component type.
  // C.render()
```

The problem/challenge is it'd need to be end-to-end typescript.

```
  // tree.subscribe('root.wat', { eager: true })
  tree.changes('root.wat', { eager: true }).subscribe(() => {
  });
```

Random abstract idea that i think is ok:

Child, while it is "subscribed" to, while the tree is alive, can
subscribe to something. You could put something on the DI graph from root,
a subscribable/observable. Ultimately, your screen is a top level matrix of
pixels that "subscribes" to this nested-then-flattened tree. And there's
no issue with that. Parameterizing the tree is no different then what
the browser needs to do to recursively paint the DOM. It's a data structure,
it gets queried. Changes to inner nodes cause global repaints.


```
<Root>
  <Parent>
    <Child></Child>
  </Parent>
</Root>






so everything's a god damn vdom factory.


return ChildNodeBuilder




import WebService from 'my-app/services/web-service';
import { provides } from 'ember-di';

class ChildNode {
  @provides
  webService(hostUrl : URL) {
    return new WebService();
  }
}
```










## ember-later






```
import { later } from 'ember-later';
import { task } from 'ember-concurrency';

export default Component.extend({
  task(function * () {
    while(true) {
      doStuff();

      // timer loop that forever pauses tests
      yield timeout(5000, 'timer-tag');
    }
  }),
});









// in ember-concurrency

import { later } from 'ember-test-timers';


let 


export function timeout(ms, testLabel) {
  let timerId;
  let promise = new Promise(r => {
    timerId = later(r, ms, testLabel);
  });
  promise.__ec_cancel__ = () => {
    // remove from internal hash
    cancel(timerId);
  };
  return promise;
}








// in ember-test-timers

export function later(callback, ms, testLabel) {
  if (Ember.testing) {

  } else {
    Ember.run.later(callback, ms);
  }
}









timerLoop: task(function * () {
  while(true) {
    this.incrementProperty('lol');
    yield timeout(5000, 'test-timer-tag');

    // once you opt into tagging a timer, you
    // risk breaking other tests that expect it to run
    // to completion. maybe the logic should be:
    // execute first one 

  }
}).on('init')




import { fetchTimers, setTimerBehavior } from 'ember-concurrency/testing';

setTimerBehavior(() => {
});

test('something', async function() {
  let timer = timeout(5000, 'test-tag'):

  while(true) {
    yield timer;
  }

  await visit('/route-w-test-timer-tag');

  // normally this would block forever due to timer loop,
  // but since a test tag ("test-timer-tag") is specified, this timer
  // doesn't resume the task (and doesn't block test settling)
  // unless explicitly queried/resumed in the test
});

```


## Difference between node and all other run of the mill objects?


Answer: probably not a lot.








```
import HasUserSessionNode from 'nodes/has-user-session';
import GetUserSessionNode from 'nodes/get-user-session';

class RootNode extends Node {
  @build
  childNode(userSession : UserSession) {
    if (userSession) {
      return new HasUserSessionNode();
    } else {
      return new GetUserSessionNode();
    }
  }

  userSession: UserSession;
}









class LoggedInNode extends Node {
  @build
  childNodes(parent : Dependency) {
  }

  wsUrl: String;

  @build
  loginService(wsUrl: String) {
  }
}
```



## childNode vs childNodes

```
  @build
  childNodes(userSession : UserSession) {
    let wat = {};

    if (thing) {
      wat.borf = new SomeNode();
    }

    if (thing2) {
      wat.borf = new SomeNode2();
    }

    if (thing3) {
      wat.borf = new SomeNode3();
    }

    return wat;
  }
```


## Gameplan

- [ ] get sync navigation working
- [ ] get observables working as a method of subscribing to changes
- [ ] explore typescript

## RenderComponent vs StateTree

In React you do RenderComponent(<App />, domElement).

I think... the DOM element is the atom. But in our case, our atom is the
in memory tree.


## So how can i use microstates here?

When something does a setState then omg... we're in the right
place to use microstates. Next up: use setState.

## McRIB vs Microstates vs React vs Glimmer:

We re-render the state tree every time.






So, maybe the rule is anything that anything that can
be swapped out is a node? Unlike React, which has to model
DOM, we have names of things. Should we make it possible to render
nodes as data? And just have the data live on the nodes?

Goals to keep in mind:

1. Strong decoupling between parent and child; parent should not
   be able to reach into children and futz around with data.
   Observables down (props?)... something/callbacks/listeners up?
2. We like the idea of state changing in a way that things are well
   scoped and get cleaned up. This might not be a real concern.
   Stable references good. So maybe just CPs.
3. What's the difference between a child node (which we should never
   touch) and a service that we materialize for downstream use? I don't know.

I like the idea of scoped computeds that get destroyed when invalidated.
Maybe they're more like owned getters with no dep keys. The worry in the past
was what if you pass the service to someone and then they outlive you?
Maybe this is something that can be prevented with DI scopes?





Cool, so anyway, how do we render to the screen?


- root
  - foo
    - bar



{{outlet 'main'}}
{{outlet 'header'}}
{{outlet 'other'}}

So render destinations should be passed in like any other destination.
For react, the render destination is passed in by way of the parent.


// ParentComponent
render() {
  return <ChildComponent />
}

// ChildComponent
render() {
  return <SubComponent />
}

// SubComponent
render() {
  return <div></div>
}

in all of these cases, render constructs a renderable. Each one implicitly gets
passed a location to render, which is... right there.


What if you could do:

// ParentComponent

render() {
  return [
    RenderBinding(<HeaderComponent />, this.props.headerComponent),
    RenderBinding(<BodyComponent />, this.props.BodyComponent),
    RenderBinding(<FooterComponent />, this.props.footerComponent),
    // presumably there'd be a default called "here"
  ];
}

class Node {
  @provides
  myService: owned(() => 
}


Would be great if we could use the Type system prevent render into something
that's already filled in; make it explicit what's a stack.


## React / Glimmer

Re-render app state everytime. As part of reconciliation, we'll make as
small changes as possible, in exactly where they need to change. Glimmer will see
these changes and efficiently render on next tick and what not. Best of both worlds?

## So how to get stuff rendering

Depends on navigation.

Imagine a transition type where you push it. You have options for
how to model that. Rules:

1. Some but not all nodes has a component/template
2. In order to render component from a node, it needs to have
   some kind of target ("outlet"?) to render into it.
   liquid-outlet is just one kind. You could also imagine
   another kind of outlet that is logical... it's a slot, that's yours
   to consume or delegate, it might logically represent the top of a stack,
   but then you render into it and you WIN! If the old pod is still around
   then it'll support sliding back. You never actually leave the route.

FlowPod
- Screen1Pod
- NavStack: []

FlowPod
- Screen1Pod
- Screen2Pod
- NavStack: [Screen1Pod]

FlowPod
- Screen1Pod
- Screen2Pod
- Screen3Pod
- NavStack: [Screen1Pod, Screen2Pod]

FlowPod
- Screen1Pod
- Screen2Pod
- Screen3Pod
- Screen4Pod
- NavStack: [Screen1Pod, Screen2Pod, Screen3Pod]

As you can see, you're adding more pods.
Possible to represent as:

FlowPod
- Screen1Pod
  - Screen2Pod
    - Screen3Pod
      - Screen4Pod
- NavStack: [Screen1Pod, Screen2Pod, Screen3Pod]

## What are blocks in this realm?

You're passing a component with some interesting binding guarantees (TCP)

The rendering component basically says, "while i'm alive, you're alive,
and during that time, you render to this slot I provide you... it's
inside me".

## Glimmer QQ: is component instance coupled to dom it maintains?

What if I wanted to teardown all the stuff on a component.

## Ember portal header use case?

How do you render into a portal that might not exist yet?

- Today the intermediary is a server that stores portal names
  in a hash.
- Technically that could still work, but much better would be:
- Declare the header slot in JS, and DI it into the header,
  and DI it into whoever wants to render into it (e.g. body).
- voila, runtime errors (especially quite ones) now fixed at compile time :)

- What's the difference between an outlet and portal/elsewhere?
  - basically both have 3 components:
    - a. the JS object/identity/atom/pipe
    - b. the component that renders into the pipe
    - c. the component that decides where to render to
  - outlet currently just reads off outlet state
    - `{{outlet}}` is c
    - the outlet name is kind of `a.` but very implicit
    - the child route that renders into requested parent outlet

## Outlet is one usecase for a pipe. So is ember-elsewhere.

## DI revelation

What's so bad about hidden dependencies?

- kinda bad but OK: they serve as documentation, so if they're hidden,
  it's hard to look at a piece of code and know what needs to change
- Much Worse: refactoring / moving things around calls late runtime breakage.
- If you want the documentation and have the means for it then drill holes,
  otherwise use the type system (I guess this is why they added types to Context?
  it's not quite DI... but it does type check... but it only type checks what
  you put in).

## Outlets

We shouldn't change terminology. Pods with components need an outlet to render into.

## Flattening the tree?




```
class DIContainer<T> {
  requiredProps: T;
}


type Token = { authToken: string };
class LoggedInNode {
  di: DIContainer<Token>;
}

class Node<R = {}> {
  di: DIContainer<R>
}

type Token = { authToken: string };

type SubContainer<N, T> = DIContainer<T & N['parent']['di']>
type DependentContainer<T> = DIContainer<T>

class LoggedInNode extends Node {
  di: DependentContainer<Token>
}

class CoolerThingThatKnowsALot extends Node {
  parent: RootNode;
  di: SubContainer<CoolerThingThatKnowsALot, Token>
  // or maybe `SubContainer<ThisType, Token>`
}


export class Node {


  // Node gets provided a compliant di container

  di : DIContainer;

  constructor(props, di) {
    this.props = props;
    this.di = di;
  }

  buildChildren() {
    return {};
  }

  willDestroy() {}

  destroy() {
    this.willDestroy();
  }
}


class RootNode extends Node {

  di : DIContainer;
}

class LoggedInNode extends Node {

  // authToken

  di : DIContainer<RootDiContainer + LoggedInStuff>;

}
```




```

WatNode * 



```

## Orthogonal Concepts

1. code is self-documenting; all dependencies are explicit
  - function calls (esp. in a null-checking-env)
  - React hole-drilling
2. coding errors fail fast
  - fastest: compile-time
  - less fast: run-time check at boot
  - worst case: findout out when a page renders or a button is clicked
      that you're passing too few/many args, or the type is wrong

Conclusions:

- the DI i want is compile-time, but not immediately obviously self documenting

## Keyed recognizer stuff

  // assume all these things are keyed.
  let o = {
    root: {
      foo_1abc: {
        foochild_borf: {
        },
        admin_2abc: {
        },
        state_myservice: {

        }
      },
      bar_2abc: {
      }
    }
  };




test('assembling the tree', function (assert) {
  // at this point we're have strands of a tree.
  // in a way we've already weeded out strands given how the recognizer
  // weeds things out. the recognizer is already being passed
  // the current state. But in order to do "when" statements you
  // need to pass through that state. What is that state? The existing
  // tree? The already "rendered" tree?

  // maybe there needs to be a second pass?
  // 1. assemble the tree
  // 2. start diffing and creating objects?


  // then what happens when state changes on this state?

});
// route-states are proxies to routes.

// <AdminStateHandler key={key}></AdminStateHandler>


// Ember.Object.extend({

//   routeMatchers: routeMatchers(function() {
//   }),

//   renderMatchers() {
//     let present = !!this.state.purchase.something ;

//     return {
//       present,
//       absent: !present,
//     }
//   }
// });

class Admin {
  renderMatchers() {

    // is it weird that recognize DOES provide state and
    // aggressively weeds things out, but then we have to take
    // a second pass to do the same thing?
    // it seems like it'd make more sense to recursively
    // generate the whole tree and THEN weed up. in a way that's
    // what route recognizer does. Maybe we need to generalize what
    // route recognizer does?

    // it is supremely weird that all of this happens in two passes.
    // it fundamentally can't really be a tree.........
    // fuck it no reason we can't leeloo dallas multipass.

    // this is only something that can be rendered


    // so we need to materialize a service object.
    // <AdminStateHandler key={key}></AdminStateHandler>

    // https://twitter.com/dan_abramov/status/981712092611989509



    let purchaseState = this.state.purchase.state;
    if (purchaseState == 'cart') {
      return {
        cart: {},

        // or, for block params
        // cart: (wat) => {
        //   123
        // };
        depends: (something) => {
          if (condition(something)) {
            return { abc: 123 };
          }
          // else return null for NO MATCH
        }
      };
    } else {
    }
  }
}

// const map = createMap([
//   route('foo', [
//     route('foochild'),
//     state('admin', (adminState) => [
//       route('posts'),
//       when(adminState.matches('cart'), [
//         ...
//       ]),
//       when(adminState, 'cart', [
//         ...
//       ]),
//       when('cart', [
//         ...
//       ]),
//       when(adminState.matches(adminState.get('otherThing')), [
//         ...
//       ]),
//       when(adminState.matches('depends', 'something'), (blockParam) => [
//         ...
//       ]),
//       when({ other: 123 }, [
//         route('comments')
//       ]),
//     ]),
//     state('my-service')
//   ]),
//   route('bar'),
// ]);


  // TODO: the whole state on the leaves shit is fucked.
  // the route recognizer coupling might simply not work out.
  // it's definitely at odds though.
  // but FUCKFACE stop getting sidetracked.
  // you can still implement the API you had in mind for your app
  // where all states are wrapping the routes. DO IT FUCKFACE.

  let map2 = createMap(() => {
    let a = state('s1');
    let b = state('s2');

    // this doesn't work as an API.
    // because there's nothing tying it to this scope.
    // unless we did something like returning it in two places (i hate this).

    return [
      a,
      b,
      route('something', () => [
        when(a.match('cart'), () => [
        ]),
        when(a.match('cart'), () => [
        ]),
      ]),
    ];
  });
    state('s1', () => [
      state('s2', () => [
        route('bar')
      ]),
    ]),
  ]);

  let map = createMap(function() {
    let s1 = this.state('s1');
    let s2 = this.state('s2');
    this.match(s1, {
      absent() {

      },
      present() [

      ],
    });
  });

    state('s1', () => [
      state('s2', () => [
        route('bar')
      ]),
    ]),
  ]);

## better router.map

route recognizer's approach doesn't allow concurrent routes in general.

it allows concurrent solutions, but because it's exhaustive the following won't work:

```
Router.map(() => {
  this.state('toplevelstate');
  this.route('foo', function() {
    // there's 2 problems:
    // 1. RR would not include toplevelstate in its solution set
    //    if the url is `/foo`, so we can't hack it... maybe we could
    //    with an asterisk '*'? TODO try this
    // 2. there's the question of refs. could either do as
    //    let toplevelref = this.state('toplevelstate'), but introducing
    //    these variables kinda sucks :(
    this.route('wat');
  });
})
```

Maybe as an experiment I should stop using `route` and just build express
everything as state constraints, where the URL is one of the constraints.




let thingWithLifespans = {
  isRendered: false,

  // import { rendered, presented } from 'lifespans';
  lifespans: () => [
    // these can be nested outside of each other or inside... depends on
    // your use case.
    rendered(() => [
    ]),


    transitioning(() => [
      {
        onTransitionTime(t, directionOrContextOrOtherData) {
          // t is a value between 0 and 1 (or beyond if allowing overshoot)
          console.log(`interactive transition t=${t}`)
        }
      }
    ])

    // perhaps the default implementation is to
    // set some value like `t` on the property that can be
    // used for animating. OR BETTER YET, expose to template
    // without clobbering host object:
    // {{#with transitioning as |t|}}
    //     transitioning. t = {{t}}
    // {{/with}}

    transitioning(),

    // by default this lifespan exposes `presented` property to template.
    // {{#with presented as |p|}}
    //   
    // {{/with}}
    // or maybe just {{if presented}}
    presented(() => [
    ]),

    when(computed.equal('foo', 'aValue'), () => [
      rendered(() => [
        {
          isRendered: true,

          pollWhileRendered: task(function * () {
            while(true) {
              yield omg();
              yield timeout(5000);
            }
          }).on('init')
        }
      ]),
    ])
  ]
}



  // lifespans can be maintained externally.
  // they already are: a component doesn't decide whether it's destroyed
  // or not; all of that is external, yet we provide a lifespan
  // interface (mostly via destroy hooks) that a thing can whatever.
  // where just making it more explicit, lexical, etc.


  // if we had lifespans would we need a new router API?

  let R = Ember.Route.extend({
    lifespans: (routeLifespanContext) => [
      modelLoaded({ name: 'modelLoaded', key: ':key_id' }, () => [
        {
          willDestroy() {
            console.log('lifespan is getting destroyed')
          }
        }
      ])

      modelLoaded({ name: 'modelLoaded', key: routeLifespanContext.param(':wat_id') }, () => [
        {
          willDestroy() {
            console.log('lifespan is getting destroyed')
          }
        }
      ])
    ]
  });

So you could imagine if you have a router map of:

```
state('auth'),
route('foo'),
```

Then your foo route could have something like

```
  let FooRoute = Ember.Route.extend({
    lifespans: (map) => [
      when(map.match('auth'), {
        present: () => [
          // ?
        ]
      })
    ]
  });
```

or use imports to make it explicit

```
  import { authenticated } from 'my-app/services/auth';

  let FooRoute = Ember.Route.extend({
    lifespans: (map) => [
      authenticated(() => [

      ])
    ],

    // this would have to somehow grab auth
    // of off the context.
    // maybe this is fine but we should at least
    // validate that SOMEONE in the map file is
    // a provider of authenticated
    loopWhileAuthenticated: task(function * () {
    }).within(authenticated)
  });
```

## Everything is a lifespan

Route definitions, models, etc.

Define things as lifespans and they can interact, overlap, do all
sorts of shit according to one grand unified mental model.

If you want a nonoverlapping lifespan, choose a better lifespan.

Or nest a known-non-overlapping lifespan.

```
import { authenticated } from 'my-app/services/auth';
import { visible } from 'ember-lifespans';

export default Ember.Component.extend({
  lifespans: () => [
    visible(() => [
      // put shared stuff on here when visible.
      // could also call this `mounted`

      presented(() => [
      ]),
    ]),
  ],

  // this would have to somehow grab auth
  // of off the context.
  // maybe this is fine but we should at least
  // validate that SOMEONE in the map file is
  // a provider of authenticated
  loopWhileAuthenticated: task(function * () {
  }).within(authenticated)
});
```

maybe go all the way with extend?

```
import { authenticated } from 'my-app/services/auth';
import { visible, extend } from 'ember-lifespans';

export default extend(Ember.Component, () => [
  presented(() => [
  ]),
]);





  lifespans: () => [
    visible(() => [
      // put shared stuff on here when visible.
      // could also call this `mounted`

      presented(() => [
      ]),
    ]),
  ],

  // this would have to somehow grab auth
  // of off the context.
  // maybe this is fine but we should at least
  // validate that SOMEONE in the map file is
  // a provider of authenticated
  loopWhileAuthenticated: task(function * () {
  }).within(authenticated)
});
```


What is the god damn difference between state and url.

URLs are broken up according to slash.

Slash segments.

within `/admin` route, given

```
/admin/foo
/admin/bar
/admin/shit




this.route('foo')
this.route('foo')
this.route('foo')



when(eq(nextSegment), [])



the url string is structured BECAUSE OF THIS VERY REASON DILLHOLE.
it delegates specifics down to stuff. it's its own tree.
You could also imagine instead of a long string separated by slashes
an address bar which is json. 

If you didn't have a url what would you use?

this.currentView = SignUp
rerender()

or in react you'd set some state and branch on it and determine
what to render...
So in the end YOU ALWAYS HAVE some piece of state that is the navigator.
What am i looking at????
transitionTo('foo')

really just means: start looking at 'foo' instead.

so with all that said is there something "flimsier" about the url
relative to other pieces of state?

Take for instance the following e.g. example, Figure 1:

-- Figure 1 Begin

when(eq(someState, 'wat'), () => [
  route('foo')
])

when(eq(someState, 'shit'), () => [
  route('foo')
])

-- Figure 1 End

Imagine if we were in someState 'wat' route 'foo'. Then someState changes to 'other'.
Obviously we'd have to "leave" the 'foo' route, but what if we didn't have to? What if instead we take corrective action? someState is "other", fuck it, we'll make it "shit", and then we won't even have to leave the route!!!!!

The only reason that doesn't work is because there's an implicit weight assigned to state based contraints relative to flyweight urls. URL is state that blows any way the winds blowing. 

So what really do we mean by

this.route('foo')
this.route('bar')

we mean

Switch([
  when(match(remainingSegment, 'foo'), FooStuff)
  when(match(remainingSegment, 'bar'), BarStuff)
])

but not just that, we also mean: if some state comes along and invalidates us, we go elsewhere. we pick a new value. there's nothing special about the URL, just that it's fragile.

What's a URL for?

- reopening the app to the correct state
  - could be replaced by localStorage and other kinds of state
- sharing with friends
- oh my god alex we fucking get it you're really smart.
- cept you can't even land this stupid feature.
- a url is like any other structured path 
  - xpath /bookstore/book[position()<3]
  - or jquery selector('root shit lol')
- this is moronic.
- urls are just enough structure to help you find the data, yet
  we've glued the concept of navigation to it
- e.g. "admin/posts"
  - you're "IN" the admin section, and looking "IN" the posts subsection
  - the admin portion is strictly navigational, doesn't really better
    describe / qualify the "posts" resource
- e.g. "posts/123/comments"
  - totally structural. describes how to fetch the data.
  - there's no section that you're in, etc.




// so what happens with the model hook?
model hooks are the gateway.

you restart the app to /admin/posts,
before model hook does promises and decides
to redirect elsewhere.

clasically you save a transition, and then retry it.
Maybe intead you want to refire an intent which turns into a workflow.



{{interactive-swipeable-outlet}}

// one way or another it's gonna pass in shit

export default Component.extend({
  lifespans: lifespan((root) => [
    presented(() => [
    ])

    mounted(() => [
    ])

    // outlets...
    // rendered
    rendered(() => [
      // header stuff is passed into this component.
    ])
  ])
})



What is the easiest way for me to finish this and bring it
to my product?

1. - [x] Must use router transitionTo in some way
2. - [x] Must have plan for pre-existing transitionTo's in the app
   (and in exc-shared code)
3. How do model hooks work?
  - let's try and make this work with redirect hooks only
  - this is how the application route works
  - redirect() might actually be perfect.
4. How does subscription happen?
  - activate/deactivate
  - and redirect... a leafier route might redirect before parent route
    can subscribe. and that's ok, we just need to de-dupe the knowledge.
  - if anything state-wise changes in the meantime, we'll need to revalidate
    things, maybe redirect into same route, etc.
5. how do flows work? doesn't matter think about it later.




- hook lifecycle
  - redirect
    - register first interest using transition
    - delegate to addon to handle this constraint magic
    - hook into transition to detect if it's aborted.
    - otherwise assume it ran to completion
    - 




Why do states / when need to be routes?

Ah



```






https://github.com/1Password/1password-teams-open-source



let wat = Ember.Route.extend({
  routeScope: computed(function () {
  }),
});

function m () {
  this.state('session', function(session) {
    session.match('absent', function(blockParam) {
      route('login');
    });

    session.match('present', function(blockParam) {
      route('profile')
    });
  });
}

// vs

function m () {
  let session = this.state('session');

  session.match('absent', function () {
    route('login');
  });

  session.match('present', function () {
    route('profile');
    route('profile');
    route('profile');
  });
}

export default createMap(() => [
  service('session', (session) => [
    session.match('sessionAbsent', () => [
      route('shopper/get-user-session', { path: '/' }),
    ]),

    session.match('sessionPresent', () => [
      route('sign-up'),
      route('sign-up/check-email'),
      route('sign-up/invite-pending'),
      route('sign-up/token-error'),
      route('sign-up/photo'),
      route('menu-frame'),
      route('locate-stores'),
      route('nearby-store', { path: '/nearby-stores/:id' }),
      route('shopper/choose-payment-type'),
      route('help-frame'),
      route('help-section', { path: "/help/:title" }),
      route('settings'),
      route('settings-frame'),
      route('settings-frame/update-name'),
      route('settings-frame/update-photo'),
      route('settings-frame/update-email'),
      route('settings-frame/update-phone-number'),
      route('settings-frame/new-card'),
      route('history-frame'),
      route('history-receipt', { path: "/history_receipt/:id" }),
      route('deals-frame'),
      route('deal-detail', { path: '/deal/:id' }),
      route('order-frame'),
      route('order-pay'),
      route('order-waiting-for-approval'),
      route('order-pay-receipt'),
      route('missing-camera-permissions'),
      route('missing-geolocation-permissions'),
      route('new-card'),
      route('purchase-complete'),
      route('pay-receipt'),
      route('pay-enter-name'),
      route('referrals-frame'),
      route('shopper/scan-frame'),
      route('shopper/unknown-cart-item'),
      route('shopper/item-lookup'),
      route('shopper/item-weight'),
      route('shopper/pay-frame'),
      route('scan-checkout-code'),
      route('checkout-code-instructions'),
      route('shopper/waiting-for-approval'),
      route('scanner-test'),
    ]),
  ]),
]);


function m2 () {
  this.route('demo', function(demoModel) {

    this.match(demoModel, 'shithead', function() {
      // this.route('login');
    });


    // current-user is only accessible to demo,
    // and any children.
    let user = this.state('current-user');

    this.match(user, 'absent', function() {
      this.route('login');
    });

    this.match(user, 'present', function() {
      let ride = this.state('current-ride');

      this.match(ride, 'notRiding', function() {
        this.route('request-ride');
      });

      this.match(ride, 'riding', function() {
        this.route('riding');
      });

      this.match(ride, 'complete', function() {
        this.route('ride-complete');
      });
    });
  });
}

export let a = createMap(() => [
  route('demo', () => [
    //state('current-user', (user) => [
    route('user/:user_id', (user) => [
      // index templere here...
      // statechange + animation problem, how to solve?

      // maybe routeValidation in 



      user.match('absent', () => [
        route('login'),
      ]),

      user.match('present', () => [
        state('current-ride', (ride) => [
          ride.match('notRiding', () => [
            route('request-ride')
          ]),
          ride.match('riding', () => [
            route('riding')
          ]),
          ride.match('complete', () => [
            route('ride-complete')
          ]),
        ])
      ]),
    ]),
  ]),
]);








import ConstraintRouter from 'dummy/services/-constraint-router';

export default Ember.Route.extend({


  foo: injectFromRoute(),
  bar: injectFromRoute(),
  baz: injectFromRoute(),


  // this can inject services.
  // anyone can inject services.
  // but this route has different lifespans:


  lifespans: {
    activated: {
      pollServer: task(function * () {
      }),
    }
  },

  lifespans: () => [
    activation({
      pollServer: task(function* () {

      }).on('init'),
    }),
  ],

  // downside to this approach: it has to be eval'd for every instance.
  lifespans(rootRouteEmberObject) {
    rootRouteEmberObject.doShit();
    this.activation({
    });
  },

  // why do i care about lifespans for routes?
  // punt on async stuff. assume sync everything.
  // but we can't punt on async because that's what's in
  // the router. So how can we make things work?
  // Use lifespans to create different objects with
  // different contexts / params / stuff.
  // Route will remain a garbage heap of state.
  // But all the good patterns will be in lifespans.
  // Or separate objects. How can we use Route objects
  // to generate these separate objects?
  // These separate objects can be outletState models?

  // Maybe I should consider an RFC where I can modularize
  // the router that's used.
  // If I could hook into the router I could replace
  // it with something with better semantics.
  // But wtf is a router anyway?

  // i should test out all these ideas in our app first.
  // there must be some way to take over all the route
  // hooks and replace it with my own.

  // then I could build up these fucking trees and
  // do whatever I want.

  // But the shopper app has so much transitionTo shit...
  // JFC what a mess.

  // stop thinking about shopper app.
  // what do we do for new Carrefour
  // maybe delegate query param to this router and
  // build what we want?

  // fair assumption.





  lifespans() {
    this.activation({
    });
  },
});

{{#each frames key="@index" as |f|}}
  <div style="width: 300px; height: 450px; border: 1px solid black; display: inline-block;">
    {{#-with-dynamic-vars outletState=f.outletState}}
      {{outlet}}
    {{/-with-dynamic-vars}}
  </div>
{{/each}}


      {{! so we set outlet state here so that outlet helper/component/glimmer
          low-level primitive will pluck it off, make a root outlet ref out of it
          and set the outlet state.

          the thing is, i need to create a new Owner.
          the outletState i create has a new context on it by which to create new
          fucking ...

          outlets are the starting point... 
          components are the shit that brings people alive.
          but the services created need to access stuff...
          so those either need a concept of the world
          or their dependencies need to be satisfied up front
          when they're eagerly created on the scope.

          so there is no inject service.
          there's dependencies that are eagerly created.

          the service objects all have references to each other.

          // in constraint-router map
          this.scopedService('foo');
          this.scopedService('bar');

          // when this scope is entered, foo/bar will be eagerly created
          // (i guess this is debatable but seems necessary for live subscriptions
          // and constraints).
          // their dependencies will be scanned and validated by scope entry.
          // they can inject global services if they want but the scoped services
          // will be validated for access.

          // in scoped-services/foo.js
          bar: scopedService(),

          the nav-stack (or maybe the microrouter?) will instantiate scoped services
          before even rendering things. so then how will components inject them? maybe
          i don't need to worry about this.

          so i'll eagerly build the services and render the component,
          passing it a scope value with all the services.

          the frame component will then have to pass it down to whoemver wants it.

      }}







// application.hbs
{{render-with-di-scope-key 'x-foo' key='123'}}

// components/x-foo.js
export default Component.extend({
  // Q: how can this inject helper
  // access the key set by `render-with-di-scope-key`??
  // What _is_ render-with-di-scope-key?
  // A component whose layout uses `-with-dynamic-vars`
  // in some way?
  // Or is it some special component manager?
  // What are my options?
  webSocket: inject.scopedService()
});

const ConstReference = Ember.__loader.require('@glimmer/reference').ConstReference;
constRef: new ConstReference('constvalue'),



import { createMap } from 'ember-constraint-router/-dsl';

export default createMap(function() {
  this.route('demo', function() {
    // this exposes a currentUser scopedService
    // to all children of demo.
    // The thing is, there's no guarantee it's present.
    // Use matchers to enforce things.
    // Or maybe matchers aren't constraints? The _CAN_
    // be constraints. They can also just expose scoped
    // services to things. When/why would you use this? Dunno.
    let auth = this.state('auth');

    // by convention, this does two things:
    // matches against 'user-absent' and declares
    // a 'user-absent' service...? maybe?
    this.match(auth, 'user-absent', function() {
      this.route('sign-in');
    });

    // match against 'current-user' and declare
    // 'current-user' service.
    // this.match(auth, 'current-user', { as: 'scoped-service-name' }, function() {
    this.match(auth, 'current-user', function() {
      let ride = this.state('ride');

      this.match(ride, 'active-ride', function(r) {

        this.match(ride, 'notRiding', function() {
          // when this does currentRide: scopedService(),
          // what are the guarantees? It'll always be present?
          // It'd be nice if that were guaranteed by the name
          // so that you didn't have to look at the router map.
          this.route('request-ride');
        });

        this.match(ride, 'riding', function() {
          this.route('riding');
          this.route('request-music');
        });

        this.match(ride, 'complete', function() {
          this.route('ride-complete');
        });
      });







      this.route('user-settings');
    });
  });
});







## Difference between a match and a guard route?

 
import { createMap } from 'ember-constraint-router/-dsl';

export default createMap(function() {
  this.route('demo', function() {
    let auth = this.state('auth');

    this.match(auth, 'user-absent', function() {
      this.route('sign-in');
    });


    // what is the difference between 'current-user'
    // match and a route called:
    // this.route('current-user', { path: '/' })
    // maybe there is no difference, but there'd need
    // to be be a way to enforce a live constraint.
    // 
    // Rule:
    // 1. all scoped services are declared in router-map?
    //    or perhaps: if it's in router-map, it might be a scoped
    //    service?


    this.match(auth, 'current-user', function() {
      let ride = this.state('ride');

      this.match(ride, 'active-ride', function(r) {

        this.match(ride, 'notRiding', function() {
          // when this does currentRide: scopedService(),
          // what are the guarantees? It'll always be present?
          // It'd be nice if that were guaranteed by the name
          // so that you didn't have to look at the router map.
          this.route('request-ride');
        });

        this.match(ride, 'riding', function() {
          this.route('riding');
          this.route('request-music');
        });

        this.match(ride, 'complete', function() {
          this.route('ride-complete');
        });
      });







      this.route('user-settings');
    });
  });
});



import { createMap } from 'ember-constraint-router/-dsl';

export default createMap(function() {
  this.route('demo', function() {
    let auth = this.state('auth');

    this.match(auth, 'user-absent', function() {
      this.route('sign-in');
    });


    // what is the difference between 'current-user'
    // match and a route called:
    // this.route('current-user', { path: '/' })
    // maybe there is no difference, but there'd need
    // to be be a way to enforce a live constraint.
    // 
    // Rule:
    // 1. all scoped services are declared in router-map?
    //    or perhaps: if it's in router-map, it might be a scoped
    //    service?


    this.match(auth, 'current-user', function() {

      // you could optionally wrap everything here in
      //
      // this.route('current-user-route-ignore-me', { path: '' })
      //
      // but this would also introduce a name in the paths of all
      // the link-to's transitionTos.


      let ride = this.state('ride');

			// the only reason to introduce this would be
			// to put a scoped service on components.
      // but maybe there can be a component-side API for scoping scoped services?
      // unwrapping them in the component, etc.
      this.match(ride, 'active-ride', function(r) {

        this.match(ride, 'notRiding', function() {
          // when this does currentRide: scopedService(),
          // what are the guarantees? It'll always be present?
          // It'd be nice if that were guaranteed by the name
          // so that you didn't have to look at the router map.
          this.route('request-ride');
        });

        this.match(ride, 'riding', function() {
          this.route('riding');
          this.route('request-music');
        });

        this.match(ride, 'complete', function() {
          this.route('ride-complete');
        });
      });







      this.route('user-settings');
    });
  });
});<Paste>









import { createMap } from 'ember-constraint-router/-dsl';

export default createMap(function() {
  this.route('demo', function() {
    let auth = this.state('auth');

    this.match(auth, 'user-absent', function() {
      this.route('sign-in');
    });

    this.match(auth, 'current-user', function() {
      this.scope(function() {
        let ride = this.state('ride');
      });

      // ? or maybe

      this.state('ride', function() {
        // block form doesn't expose it to parent??
      });

      let ride = this.state('ride');

      this.match(ride, 'notRiding', function() {
        this.route('request-ride');
      });

      this.match(ride, 'riding', function() {
        this.route('riding');
        this.route('request-music');
      });

      this.match(ride, 'complete', function() {
        this.route('ride-complete');
      });

      this.route('user-settings');
    });
  });
});





  let r = {
    scopeData: {
      key: 'k_user_id=machty',
      params: { user_id: 'machty' }
    },
    load(value) {
      // 1. It should be possible to reload data here.
      // 2. It should be possible for a websocket to push new data here.




      // provide some api for loading data.
      // maybe it has access to everything on the scope.
      // maybe it just loads all the shit.

      // so it can just broacast stuff, including eventually some errors / invalidations / transitions.
      // or should transitions happen elsewhere? should they be on the frame?

      let xhr = $.ajax();
      return () => {
        xhr.abort();
        // turn off subscription.
      }
    }
  };


export default class extends Route {
  static provides() { return ['user', 'myScopedService']; }

  user({ user_id }) {
    let user = { id: user_id, name: 'alex' };
    return new Promise(r => {
      setTimeout(() => {
        r(user);
      }, 800);
    });
  }

  myScopedService() {
    return new FunService();
  }
}





## Multiple provisions: should data nodes expand into multiple routes when they provide multiple things?


    // dataNodes know the name of the data they're resolving.

    // rule: if you use provides, you can name the thing.
    // if you don't, you use `model`.

    // FUCK how do we get 3 data nodes to share the
    // same route? need an ownership / refcounting system.
    // which totally sucks.
    // alternative plan?
    // 1 DataNode per route.
    // DataNode can provide multiple things.
    // DataNode has one instance of route.
    // 
    // this sucks because it hardcodes ownership based on DataNode,
    // and prevents you from having different Routes.
    // BUT i can' think iof a use case so I AM GOING TO DO THIS NOW.
    // comments below left for posterity.

    // what if, instead, you have one DataNode per provides.
    // a DataNode represents one node in the DI tree.
    // It will materialize a loader (Route) from its
    // DataNodeResolver (hmm but currently this is stateless).
    // There needs to be some kind of scope/cache of Routes...
    // ALL of these routes' lifespans will be scoped to the...
    // FrameScope?
    // There's a FrameScope per frame. One url per frame.

    // So /foo/users/machty/lol, the users route might provide
    // two things: user and userMeta



    // Foo provides 2 things.
    // Bar depends on ... one of the things?
    // What does it mean for a data node to have 2 dependencies?
    // What if those dependencies change? Reload the thing?
    // At a low level, when you request dependencies, you're given
    // a DataNode as a reference... kinda like an observable.

    class Wat extends Route {
      static di() {
        // return an object that describes what each object
        // receives, how it invalides?
        // is this at odds with observables?
        // What are the use cases for this? Do I need to solve this?
        // What happens when they depend on each other?

        // NEVERMIND: HERE IS WHAT I AM SOLVING TODAY:
        // You have params. You load the model depending on params.
        // It's assumed you depend on params.
        // Each frame oijoij


        return {
          foo: new PromiseyDependency(),
          bar: new PromiseyDependency(),
        };
      }
    }<Paste>











    "ember-cli-addon-docs": "^0.5.0",
    "ember-cli-addon-docs-yuidoc": "^0.2.1",




































