# TODO

- serializable state tree
- then we turn that into an object tree
  - this is desirable because at some point we'll want to be able to save navigation somewhere; needs to be json
- currently we're doing this with recomputeState set.
- but we shouldn't do this.


```json
{
  "key": "SwitchRouterBase",
  "routeName": "auth",
  "index": 1,
  "routes": [
    {
      "params": null,
      "routeName": "foo",
      "key": "id-1567042452553-6",
    },
    {
      "params": null,
      "routeName": "bar",
      "key": "id-1567042452553-6",
    }
  ]
}
```

hydrates

```js
{
  routeState: routeStateAbove,
  componentName: "thing",
  config: ConfigObject,
}
```

Here's everything on descriptors

```
descriptors[route.key] = {
  key: route.key,
  getComponent,
  options,
  state: route,
  navigation: childNavigation,
};
```




## Lifecycle

You define a router map as follows:

```js
switchRoute('auth', [
  route('foo'),
  route('bar'),
]);
```

This returns a reducer that you can dispatch actions on. This reducer, a la Redux,
will return a brand new POJO representing the next navigation state to transition to.
The initial state given the above map would be:

```json
{
  "key": "SwitchRouterBase",
  "routeName": "auth",
  "index": 0,
  "routes": [
    {
      "params": null,
      "routeName": "foo",
      "key": "id-1567042452553-6",
    },
    {
      // TODO: we might change this to make it null; unclear why we're entering it in the first place.
      "params": null,
      "routeName": "bar",
      "key": "id-1567042452553-6",
    }
  ]
}
```

What are the benefits do doing it this way?

- You can explore what the state _would_ be with a transition
- All the benefits of statelessness in design

What are the cons?

- You have adjacent tree structures, the stateless redux tree next to the MountedNode tree.
  Navigation delegates to the stateless tree for some reason. Traversing the MountedNode tree
  means traversing the other (some of this could be fixed with better design)
  







The next step is where we differ from React Navigation; at this point, RN would pass
this reducer state to its AppContainer component and render this whole tree. I am avoiding
this because I don't want route "lifecycles" to be coupled to rendered components. For instance,
I want it to be possible for a route `xyz` to be pushed to a stack, but not necessarily have
the `xyz` component to be rendered in cases where other frames have been pushed over it.
I want a stable Route object to be the active living object that persists so long as it is
part of the navigation tree, and it is this Route object that is passed to each rendered
"Routeable Component" that drives it with data.

So the next step is to build a tree of `MountedNode`s:

```js
MountedNode(
  componentName: 'ecr-stack',
  key: 'SwitchRouterBase',
  childNodes: {
  }

  // childNodes: MountedNodeSet;
  // resolver: Resolver;
  // routeableState?: RouteableState;
  // componentName: string;
  // route: PublicRoute;

)
```



















