import MountedRouter from './-private/mounted-router';
import { RouteReducer } from './-private/route-reducer';
import { StackRouter } from './-private/routers/stack-router';
import { SwitchRouter } from './-private/routers/switch-router';
import { TabRouter } from './-private/routers/tab-router';
import type { RouteOptions } from './-private/route-reducer';
import type { Resolver, RouteableReducer, RouterReducer } from './-private/routeable';
import type { StackOptions } from './-private/routers/stack-router';
import type { SwitchOptions } from './-private/routers/switch-router';
import type { TabOptions } from './-private/routers/tab-router';
export { default as NavigatorRoute } from './-private/navigator-route';
export declare function mount(routerMap: RouterReducer, resolver: Resolver): MountedRouter;
export declare function route(name: string, options?: RouteOptions): RouteReducer;
export declare function stackRouter(name: string, children: RouteableReducer[], options?: StackOptions): StackRouter;
export declare function switchRouter(name: string, children: RouteableReducer[], options?: SwitchOptions): SwitchRouter;
export declare function tabRouter(name: string, children: RouteableReducer[], options?: TabOptions): TabRouter;
